/* A Bison parser, made from /home/bruenen/Projects/cvsgui/cvsgui/cvstree/parser.yy, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INTEGER = 258,
     STRING = 259,
     TAG = 260,
     REVNUM = 261,
     REVNUMLISTITEM = 262,
     ID_CHAR = 263,
     ID_DESCRIPTION = 264,
     ID_TOTREVISIONS = 265,
     ID_SELREVISIONS = 266,
     ID_KEYWORD = 267,
     ID_SYMBOLIC = 268,
     ID_ACCESS = 269,
     ID_LOCKS = 270,
     ID_STRICT = 271,
     ID_BRANCH = 272,
     ID_HEAD = 273,
     ID_WORKING = 274,
     ID_RCS = 275,
     ID_REVISION = 276,
     ID_DATE = 277,
     ID_BRANCHES = 278,
     ID_REVFOLLOW = 279,
     ID_ENDFOLLOW = 280,
     ID_LINES = 281,
     ID_ANYBUTSEP = 282,
     ID_LOCKEDBY = 283,
     ID_AUTHOR = 284,
     ID_STATE = 285,
     ID_COMMITID = 286,
     ID_KOPT = 287,
     ID_MERGEPOINT = 288
   };
#endif
#define INTEGER 258
#define STRING 259
#define TAG 260
#define REVNUM 261
#define REVNUMLISTITEM 262
#define ID_CHAR 263
#define ID_DESCRIPTION 264
#define ID_TOTREVISIONS 265
#define ID_SELREVISIONS 266
#define ID_KEYWORD 267
#define ID_SYMBOLIC 268
#define ID_ACCESS 269
#define ID_LOCKS 270
#define ID_STRICT 271
#define ID_BRANCH 272
#define ID_HEAD 273
#define ID_WORKING 274
#define ID_RCS 275
#define ID_REVISION 276
#define ID_DATE 277
#define ID_BRANCHES 278
#define ID_REVFOLLOW 279
#define ID_ENDFOLLOW 280
#define ID_LINES 281
#define ID_ANYBUTSEP 282
#define ID_LOCKEDBY 283
#define ID_AUTHOR 284
#define ID_STATE 285
#define ID_COMMITID 286
#define ID_KOPT 287
#define ID_MERGEPOINT 288




/* Copy the first part of user declarations.  */
#line 1 "parser.yy"

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "common.h"

#if qCvsDebug
#	define YYDEBUG 1
#else
#	define YYDEBUG 0
#endif

#ifdef __MWERKS__
	using namespace std;
#endif

static void expect(kTokens type);

static int sInt;
static CLogStr sStr;
static CRevNumber sRev;

static void printDebug(const char *tag, const char* value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%s%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}

static void printDebug(const char *tag, int value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%d%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
#line 60 "parser.yy"
typedef union {
	char *string;
	int aint;
} yystype;
/* Line 193 of /usr/share/bison/yacc.c.  */
#line 203 "parser.cc"
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 224 "parser.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
#define YYLAST   95

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  37
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  69
/* YYNRULES -- Number of rules. */
#define YYNRULES  109
/* YYNRULES -- Number of states. */
#define YYNSTATES  140

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    36,    34,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    11,    12,    16,    18,
      19,    23,    24,    28,    29,    32,    34,    36,    38,    40,
      42,    44,    46,    48,    50,    52,    53,    56,    57,    59,
      61,    62,    66,    67,    70,    71,    73,    75,    79,    80,
      82,    86,    87,    88,    92,    93,    97,    98,    99,   100,
     101,   102,   103,   104,   122,   123,   127,   130,   131,   135,
     136,   137,   143,   144,   148,   149,   153,   154,   158,   159,
     162,   163,   165,   167,   169,   171,   172,   173,   179,   180,
     181,   186,   187,   191,   194,   195,   198,   199,   204,   207,
     208,   211,   212,   216,   218,   219,   223,   224,   229,   230,
     233,   234,   239,   240,   244,   245,   249,   250,   254,   255
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      38,     0,    -1,    39,    -1,    -1,    39,    40,    -1,    44,
      -1,    -1,    24,    41,    52,    -1,    25,    -1,    -1,     1,
      42,    46,    -1,    -1,    75,    43,    46,    -1,    -1,    44,
      45,    -1,   104,    -1,   102,    -1,   100,    -1,    98,    -1,
      92,    -1,    88,    -1,    84,    -1,    82,    -1,    77,    -1,
      48,    -1,    -1,    46,    47,    -1,    -1,     8,    -1,     4,
      -1,    -1,     9,    49,    50,    -1,    -1,    50,    51,    -1,
      -1,     8,    -1,     4,    -1,    56,    53,    54,    -1,    -1,
      58,    -1,    53,    34,    58,    -1,    -1,    -1,    23,    55,
      72,    -1,    -1,    21,    57,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    59,    76,    35,    60,    76,
      35,    61,    76,    62,    76,    36,    63,    76,    36,    64,
      76,    -1,    -1,    29,    65,    74,    -1,    28,    75,    -1,
      -1,    30,    66,    74,    -1,    -1,    -1,    26,    67,    76,
      68,    76,    -1,    -1,    32,    69,    74,    -1,    -1,    31,
      70,    74,    -1,    -1,    33,    71,     6,    -1,    -1,    72,
      73,    -1,    -1,     7,    -1,     4,    -1,     5,    -1,     3,
      -1,    -1,    -1,    10,    78,    76,    79,    80,    -1,    -1,
      -1,    34,    11,    81,    76,    -1,    -1,    12,    83,    74,
      -1,    13,    85,    -1,    -1,    85,    86,    -1,    -1,    75,
      36,    87,     6,    -1,    14,    89,    -1,    -1,    89,    90,
      -1,    -1,    75,    91,    75,    -1,    75,    -1,    -1,    15,
      93,    95,    -1,    -1,    15,    16,    94,    95,    -1,    -1,
      95,    96,    -1,    -1,    75,    36,    97,     6,    -1,    -1,
      17,    99,     6,    -1,    -1,    18,   101,     6,    -1,    -1,
      19,   103,    74,    -1,    -1,    20,   105,    74,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   102,   102,   105,   107,   110,   112,   112,   123,   124,
     124,   134,   134,   146,   147,   150,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   163,   165,   168,   170,   177,
     187,   186,   191,   193,   196,   198,   203,   210,   213,   214,
     215,   218,   219,   219,   224,   223,   236,   237,   238,   244,
     250,   256,   262,   237,   282,   282,   291,   299,   299,   308,
     309,   308,   325,   325,   334,   334,   342,   342,   352,   354,
     357,   359,   370,   374,   378,   383,   384,   382,   393,   395,
     395,   405,   404,   414,   418,   420,   424,   423,   443,   447,
     449,   453,   452,   462,   473,   472,   480,   480,   489,   491,
     495,   494,   515,   514,   527,   526,   539,   538,   550,   549
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "STRING", "TAG", "REVNUM", 
  "REVNUMLISTITEM", "ID_CHAR", "ID_DESCRIPTION", "ID_TOTREVISIONS", 
  "ID_SELREVISIONS", "ID_KEYWORD", "ID_SYMBOLIC", "ID_ACCESS", "ID_LOCKS", 
  "ID_STRICT", "ID_BRANCH", "ID_HEAD", "ID_WORKING", "ID_RCS", 
  "ID_REVISION", "ID_DATE", "ID_BRANCHES", "ID_REVFOLLOW", "ID_ENDFOLLOW", 
  "ID_LINES", "ID_ANYBUTSEP", "ID_LOCKEDBY", "ID_AUTHOR", "ID_STATE", 
  "ID_COMMITID", "ID_KOPT", "ID_MERGEPOINT", "';'", "'/'", "':'", 
  "$accept", "cvslog", "allDeclarations", "allDeclaration", "@1", "@2", 
  "@3", "rcsDeclarations", "rcsDeclaration", "anyDeclarations", 
  "anyDeclaration", "descDeclaration", "@4", "descListDeclarations", 
  "descListDeclaration", "allrevDeclarations", "revOtherDeclarations", 
  "revBranches", "@5", "revRevision", "@6", "revOtherDeclaration", "@7", 
  "@8", "@9", "@10", "@11", "@12", "@13", "@14", "@15", "@16", "@17", 
  "@18", "@19", "revnumListDeclarations", "revnumListDeclaration", 
  "stringDeclaration", "tagDeclaration", "intDeclaration", 
  "totRevDeclaration", "@20", "@21", "selRevDeclaration", "@22", 
  "keyDeclaration", "@23", "symbolicNamesDeclaration", 
  "symbolicListDeclarations", "symbolicListDeclaration", "@24", 
  "accessDeclaration", "accessListDeclarations", "accessListDeclaration", 
  "@25", "locksDeclaration", "@26", "@27", "locksListDeclarations", 
  "locksListDeclaration", "@28", "branchRevDeclaration", "@29", 
  "headRevDeclaration", "@30", "workingFileDeclaration", "@31", 
  "rcsFileDeclaration", "@32", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    59,    47,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    37,    38,    39,    39,    40,    41,    40,    40,    42,
      40,    43,    40,    44,    44,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    46,    46,    47,    47,    47,
      49,    48,    50,    50,    51,    51,    51,    52,    53,    53,
      53,    54,    55,    54,    57,    56,    58,    59,    60,    61,
      62,    63,    64,    58,    65,    58,    58,    66,    58,    67,
      68,    58,    69,    58,    70,    58,    71,    58,    72,    72,
      73,    73,    74,    75,    76,    78,    79,    77,    80,    81,
      80,    83,    82,    84,    85,    85,    87,    86,    88,    89,
      89,    91,    90,    90,    93,    92,    94,    92,    95,    95,
      97,    96,    99,    98,   101,   100,   103,   102,   105,   104
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     1,     0,     3,     1,     0,
       3,     0,     3,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     0,     1,     1,
       0,     3,     0,     2,     0,     1,     1,     3,     0,     1,
       3,     0,     0,     3,     0,     3,     0,     0,     0,     0,
       0,     0,     0,    17,     0,     3,     2,     0,     3,     0,
       0,     5,     0,     3,     0,     3,     0,     3,     0,     2,
       0,     1,     1,     1,     1,     0,     0,     5,     0,     0,
       4,     0,     3,     2,     0,     2,     0,     4,     2,     0,
       2,     0,     3,     1,     0,     3,     0,     4,     0,     2,
       0,     4,     0,     3,     0,     3,     0,     3,     0,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     0,     1,     9,    73,     6,     8,     4,     5,
      11,    25,     0,    30,    75,    81,    84,    89,    94,   102,
     104,   106,   108,    14,    24,    23,    22,    21,    20,    19,
      18,    17,    16,    15,    25,    10,    44,     7,    38,    32,
       0,     0,    83,    88,    96,    98,     0,     0,     0,     0,
      12,    29,    28,    26,     0,    47,    59,     0,    54,    57,
      64,    62,    66,    41,    39,    31,    74,    76,    72,    82,
       0,    85,    93,    90,    98,    95,   103,   105,   107,   109,
      45,     0,     0,    56,     0,     0,     0,     0,     0,    42,
      46,    37,    36,    35,    33,    78,    86,     0,    97,     0,
      99,     0,    60,    55,    58,    65,    63,    67,    68,    40,
       0,    77,     0,    92,   100,    48,     0,    43,    79,    87,
       0,     0,    61,    71,    69,     0,   101,     0,    80,    49,
       0,    50,     0,     0,    51,     0,     0,    52,     0,    53
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     2,     8,    12,    11,    34,     9,    23,    35,
      53,    24,    39,    65,    94,    37,    63,    91,   108,    38,
      54,    64,    81,   121,   130,   132,   135,   138,    84,    85,
      82,   116,    87,    86,    88,   117,   124,    69,    99,    67,
      25,    40,    95,   111,   125,    26,    41,    27,    42,    71,
     112,    28,    43,    73,    97,    29,    45,    74,    75,   100,
     120,    30,    46,    31,    47,    32,    48,    33,    49
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -80
static const yysigned_char yypact[] =
{
     -80,     1,     4,   -80,   -80,   -80,   -80,   -80,   -80,    48,
     -80,   -80,   -14,   -80,   -80,   -80,   -80,   -80,     9,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,     2,   -80,   -80,    47,   -80,
       5,    16,    25,    25,   -80,   -80,    26,    27,    16,    16,
       2,   -80,   -80,   -80,    28,   -80,   -80,    25,   -80,   -80,
     -80,   -80,   -80,    -8,   -80,    23,   -80,   -80,   -80,   -80,
      -1,   -80,    31,   -80,   -80,    25,   -80,   -80,   -80,   -80,
     -80,     5,     5,   -80,    16,    16,    16,    16,    32,   -80,
      47,   -80,   -80,   -80,   -80,    10,   -80,    25,    25,     3,
     -80,     8,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
      34,   -80,    46,   -80,   -80,   -80,     5,    57,   -80,   -80,
      64,     5,   -80,   -80,   -80,     5,   -80,    19,   -80,   -80,
       5,   -80,     5,    35,   -80,     5,    36,   -80,     5,   -80
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,    40,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,    -9,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -37,    -2,   -79,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,    11,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -92
static const short yytable[] =
{
      10,     3,   101,   102,    -2,     4,    51,    36,    66,     5,
      52,    78,    79,   -13,   -13,    89,   -13,   -13,   -13,   -13,
      68,   -13,   -13,   -13,   -13,    44,    90,    92,     6,     7,
       5,    93,    76,    77,    80,    96,   -91,   122,   107,   114,
      70,    72,   127,   115,   110,   118,   128,   103,   104,   105,
     106,   131,   119,   133,   129,    83,   136,    13,    14,   139,
      15,    16,    17,    18,   123,    19,    20,    21,    22,    55,
     126,   134,   137,    56,    50,    57,    58,    59,    60,    61,
      62,   109,     0,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   113
};

static const short yycheck[] =
{
       2,     0,    81,    82,     0,     1,     4,    21,     3,     5,
       8,    48,    49,     9,    10,    23,    12,    13,    14,    15,
       4,    17,    18,    19,    20,    16,    34,     4,    24,    25,
       5,     8,     6,     6,     6,    36,     5,   116,     6,    36,
      42,    43,   121,    35,    34,    11,   125,    84,    85,    86,
      87,   130,     6,   132,    35,    57,   135,     9,    10,   138,
      12,    13,    14,    15,     7,    17,    18,    19,    20,    22,
       6,    36,    36,    26,    34,    28,    29,    30,    31,    32,
      33,    90,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    97
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    38,    39,     0,     1,     5,    24,    25,    40,    44,
      75,    42,    41,     9,    10,    12,    13,    14,    15,    17,
      18,    19,    20,    45,    48,    77,    82,    84,    88,    92,
      98,   100,   102,   104,    43,    46,    21,    52,    56,    49,
      78,    83,    85,    89,    16,    93,    99,   101,   103,   105,
      46,     4,     8,    47,    57,    22,    26,    28,    29,    30,
      31,    32,    33,    53,    58,    50,     3,    76,     4,    74,
      75,    86,    75,    90,    94,    95,     6,     6,    74,    74,
       6,    59,    67,    75,    65,    66,    70,    69,    71,    23,
      34,    54,     4,     8,    51,    79,    36,    91,    95,    75,
      96,    76,    76,    74,    74,    74,    74,     6,    55,    58,
      34,    80,    87,    75,    36,    35,    68,    72,    11,     6,
      97,    60,    76,     7,    73,    81,     6,    76,    76,    35,
      61,    76,    62,    76,    36,    63,    76,    36,    64,    76
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 6:
#line 112 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->AllRevs().push_back(CRevFile());
				gRevFile = &gRcsFile->LastRev();
			}

			expect (kRev);
		}
    break;

  case 8:
#line 123 "parser.yy"
    { gRcsFile = 0L; expect(kNone); }
    break;

  case 9:
#line 124 "parser.yy"
    {
										int c = yyvsp[0].aint;
										yyclearin;
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << (char)c;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << (char)c;
									}
    break;

  case 11:
#line 134 "parser.yy"
    {
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << sStr;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << sStr;

										printDebug("Desp ", sStr.c_str(), true);
    }
    break;

  case 28:
#line 170 "parser.yy"
    {
							char c = yyvsp[0].aint;
							if(gRevFile != 0L)
								gRevFile->DescLog() << c;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << c;
						}
    break;

  case 29:
#line 177 "parser.yy"
    {
							if(gRevFile != 0L)
								gRevFile->DescLog() << yyvsp[0].string;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << yyvsp[0].string;
							free(yyvsp[0].string);
						}
    break;

  case 30:
#line 187 "parser.yy"
    { expect(kAnyButSep); }
    break;

  case 35:
#line 198 "parser.yy"
    {
			char c = yyvsp[0].aint;
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << c;
		}
    break;

  case 36:
#line 203 "parser.yy"
    {
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << yyvsp[0].string;
			free(yyvsp[0].string);
		}
    break;

  case 42:
#line 219 "parser.yy"
    { expect(kRevList); }
    break;

  case 44:
#line 224 "parser.yy"
    { expect(kRevnum); }
    break;

  case 45:
#line 225 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				printDebug("\nRevNum ", sRev.c_str(), true);

				gRevFile->RevNum() = sRev;
			}
			sRev.reset();
		}
    break;

  case 47:
#line 237 "parser.yy"
    { expect(kDate); }
    break;

  case 48:
#line 238 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_year = sInt - 1900;
			}
		}
    break;

  case 49:
#line 244 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mon = sInt;
			}
		}
    break;

  case 50:
#line 250 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mday = sInt;
			}
		}
    break;

  case 51:
#line 256 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_hour = sInt;
			}
		}
    break;

  case 52:
#line 262 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_min = sInt;
			}
		}
    break;

  case 53:
#line 268 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_sec = sInt;
			}

			expect(kNone);
			
			if(gRevFile != 0L)
			{
				printDebug("Date ", asctime(&(gRevFile->RevTime())), false);
			}
		}
    break;

  case 54:
#line 282 "parser.yy"
    { expect(kAuthorValue); }
    break;

  case 55:
#line 283 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->Author() = sStr;
				printDebug("Author ", sStr.c_str(), true);
			}
		}
    break;

  case 56:
#line 292 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->Locker() = sStr;
				printDebug("Locker ", sStr.c_str(), true);
			}
		}
    break;

  case 57:
#line 299 "parser.yy"
    { expect(kState); }
    break;

  case 58:
#line 300 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->State() = sStr;
                printDebug("State ", sStr.c_str(), true);
			}
		}
    break;

  case 59:
#line 308 "parser.yy"
    { expect(kInt); }
    break;

  case 60:
#line 309 "parser.yy"
    {
			expect(kInt);
			if(gRevFile != 0L)
			{
				gRevFile->ChgPos() = sInt;
				printDebug("Lines +", sInt, false);
			}
		}
    break;

  case 61:
#line 317 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->ChgNeg() = sInt;
				printDebug(" ", sInt, true);
			}
		}
    break;

  case 62:
#line 325 "parser.yy"
    { expect(kKeyword); }
    break;

  case 63:
#line 326 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->KeywordSubst() = sStr;
				printDebug("KeywordSubst ", sStr.c_str(), true);
			}			
		}
    break;

  case 64:
#line 334 "parser.yy"
    { expect(kID); }
    break;

  case 65:
#line 335 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->CommitID() = sStr;
				printDebug("CommitID ", sStr.c_str(), true);
			}
		}
    break;

  case 66:
#line 342 "parser.yy"
    { expect(kRevnum); }
    break;

  case 67:
#line 343 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->MergePoint() = sRev;
				printDebug("MergePoint ",sRev.c_str(),true);
			}
		}
    break;

  case 71:
#line 359 "parser.yy"
    {
			if(gRevFile != 0L)
			{
				gRevFile->BranchesList().push_back(sRev);
			}

			sRev.reset();
			expect(kRevList);
		}
    break;

  case 72:
#line 371 "parser.yy"
    { sStr = yyvsp[0].string; free(yyvsp[0].string); }
    break;

  case 73:
#line 375 "parser.yy"
    { sStr = yyvsp[0].string; free(yyvsp[0].string); }
    break;

  case 74:
#line 379 "parser.yy"
    { sInt = yyvsp[0].aint; }
    break;

  case 75:
#line 383 "parser.yy"
    { expect(kInt); }
    break;

  case 76:
#line 384 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->TotRevisions() = sInt;
			}
		}
    break;

  case 79:
#line 395 "parser.yy"
    { expect(kInt); }
    break;

  case 80:
#line 396 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->SelRevisions() = sInt;
			}
		}
    break;

  case 81:
#line 405 "parser.yy"
    { expect(kKeyword); }
    break;

  case 82:
#line 406 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->KeywordSubst() = sStr;
			}
		}
    break;

  case 86:
#line 424 "parser.yy"
    {
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->SymbolicList().push_back(newRev);
			}
		}
    break;

  case 87:
#line 433 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastSymbName().Tag();
				gRcsFile->LastSymbName() = sRev;
			}
			sRev.reset();
		}
    break;

  case 91:
#line 453 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		}
    break;

  case 93:
#line 462 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		}
    break;

  case 94:
#line 473 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = false;
			}
		}
    break;

  case 96:
#line 480 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = true;
			}
		}
    break;

  case 100:
#line 495 "parser.yy"
    {
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->LocksList().push_back(newRev);
			}
		}
    break;

  case 101:
#line 504 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastLock().Tag();
				gRcsFile->LastLock() = sRev;
			}
			sRev.reset();
		}
    break;

  case 102:
#line 515 "parser.yy"
    { expect(kRevnumOrNil); }
    break;

  case 103:
#line 516 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->BranchRev() = sRev;
				printDebug("Branch :", sRev.c_str(), true);
			}
			sRev.reset();
		}
    break;

  case 104:
#line 527 "parser.yy"
    { expect(kRevnum); }
    break;

  case 105:
#line 528 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->HeadRev() = sRev;
				printDebug("Head :", sRev.c_str(), true);
			}
			sRev.reset();
		}
    break;

  case 106:
#line 539 "parser.yy"
    { expect(kString); }
    break;

  case 107:
#line 540 "parser.yy"
    {
			if(gRcsFile != 0L)
			{
				gRcsFile->WorkingFile() = sStr;
				printDebug("WorkingFile :", sStr, true);
			}
		}
    break;

  case 108:
#line 550 "parser.yy"
    { expect(kString); }
    break;

  case 109:
#line 551 "parser.yy"
    {
			// push a new rcs file
			gRcsFiles.push_back(CRcsFile());
			gRcsFile = &gRcsFiles[gRcsFiles.size() - 1];
			gRcsFile->RcsFile() = sStr;
		}
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1720 "parser.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 558 "parser.yy"


void yyerror(const char * /*txt*/, ...)
{
	expect(kAnyButSep);
}

static void expect(kTokens type)
{
	expectToken = type;
}

void yylval_set(const char *txt)
{
	yylval.string = strdup(txt);
}

void yylval_set(int anint)
{
	yylval.aint = anint;
}

void yylval_set(const CRevNumber & rev)
{
	sRev = rev;
}

void yyreset(void)
{
	currentLineNumber = 1;
	sStr = "";
	sInt = 0;
	sRev.reset();
	gRcsFiles.erase(gRcsFiles.begin(), gRcsFiles.end());
	gRcsFile = 0L;
	gRevFile = 0L;
	expect(kNone);
}

